import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import * as wjcCore from '@mescius/wijmo';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import './styles.css';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let workbook;
//
document.querySelector('#importFile').addEventListener('change', () => {
loadWorkbook();
});
//
document.querySelector('#sheetNav').addEventListener('click', (e) => {
e.preventDefault();
//
let navEle = e.target.parentElement;
let activeIndex = toggleNavActiveStatus(navEle);
if (activeIndex !== -1) {
drawSheet(activeIndex);
}
});
//
function loadWorkbook() {
let reader = new FileReader();
//
reader.onload = (e) => {
let tmp = new wjcXlsx.Workbook();
tmp.loadAsync(reader.result, (result) => {
workbook = result;
drawSheetNav(workbook.activeWorksheet || 0);
drawSheet(workbook.activeWorksheet || 0);
});
};
//
let file = document.getElementById('importFile').files[0];
if (file) {
reader.readAsDataURL(file);
}
}
//
function drawSheet(sheetIndex) {
let drawRoot = document.getElementById('tableHost');
drawRoot.textContent = '';
drawWorksheet(workbook, sheetIndex, drawRoot, 200, 100);
}
//
function drawSheetNav(activeIndex) {
let contianer = document.querySelector('#sheetNav');
contianer.innerHTML = '';
let navItem = '';
for (let i = 0; i < workbook.sheets.length; i++) {
let sheet = workbook.sheets[i];
navItem += `<li role="presentation" class="${i === activeIndex ? 'active' : ''}"><a href="#">${sheet.name}</a></li>`;
}
contianer.innerHTML = navItem;
}
//
function drawWorksheet(workbook, sheetIndex, rootElement, maxRows, maxColumns) {
//NOTES:
//Empty cells' values are numeric NaN, format is "General"
//
//Excessive empty properties:
//fill.color = undefined
//
// netFormat should return '' for ''. What is 'General'?
// font.color should start with '#'?
// Column/row styles are applied to each cell style, this is convenient, but Column/row style info should be kept,
// for column/row level styling
// formats conversion is incorrect - dates and virtually everything; netFormat - return array of formats?
// ?row heights - see hello.xlsx
if (!workbook || !workbook.sheets || sheetIndex < 0 || workbook.sheets.length == 0) {
return;
}
//
sheetIndex = Math.min(sheetIndex, workbook.sheets.length - 1);
//
if (maxRows == null) {
maxRows = 200;
}
//
if (maxColumns == null) {
maxColumns = 100;
}
//
// Namespace and XlsxConverter shortcuts.
let sheet = workbook.sheets[sheetIndex], defaultRowHeight = 20, defaultColumnWidth = 60, tableEl = document.createElement('table');
//
tableEl.border = '1';
tableEl.style.borderCollapse = 'collapse';
//
let maxRowCells = 0;
for (let r = 0; sheet.rows && r < sheet.rows.length; r++) {
if (sheet.rows[r] && sheet.rows[r].cells) {
maxRowCells = Math.max(maxRowCells, sheet.rows[r].cells.length);
}
}
//
// add columns
let columns = sheet.columns || [], invisColCnt = columns.filter(col => col.visible === false).length;
//
if (sheet.columns) {
maxRowCells = Math.min(Math.max(maxRowCells, columns.length), maxColumns);
//
for (let c = 0; c < maxRowCells; c++) {
let col = columns[c];
//
if (col && !col.visible) {
continue;
}
//
let colEl = document.createElement('col');
tableEl.appendChild(colEl);
let colWidth = defaultColumnWidth + 'px';
if (col) {
importStyle(colEl.style, col.style);
if (col.autoWidth) {
colWidth = '';
}
else if (col.width != null) {
colWidth = col.width + 'px';
}
}
colEl.style.width = colWidth;
}
}
//
// generate rows
let rowCount = Math.min(maxRows, sheet.rows.length);
for (let r = 0; sheet.rows && r < rowCount; r++) {
let row = sheet.rows[r], cellsCnt = 0; // including colspan
//
if (row && !row.visible) {
continue;
}
//
let rowEl = document.createElement('tr');
tableEl.appendChild(rowEl);
//
if (row) {
importStyle(rowEl.style, row.style);
if (row.height != null) {
rowEl.style.height = row.height + 'px';
}
//
for (let c = 0; row.cells && c < row.cells.length; c++) {
let cell = row.cells[c], cellEl = document.createElement('td'), col = columns[c];
//
if (col && !col.visible) {
continue;
}
//
cellsCnt++;
//
rowEl.appendChild(cellEl);
if (cell) {
importStyle(cellEl.style, cell.style);
let value = cell.value;
//
if (!(value == null || value !== value)) { // TBD: check for NaN should be eliminated
if (wjcCore.isString(value) && value.charAt(0) == "'") {
value = value.substr(1);
}
let netFormat = '';
if (cell.style && cell.style.format) {
netFormat = wjcXlsx.Workbook.fromXlsxFormat(cell.style.format)[0];
}
let fmtValue = netFormat ? wjcCore.Globalize.format(value, netFormat) : value;
cellEl.innerHTML = wjcCore.escapeHtml(fmtValue);
}
//
if (cell.colSpan && cell.colSpan > 1) {
cellEl.colSpan = getVisColSpan(columns, c, cell.colSpan);
cellsCnt += cellEl.colSpan - 1;
c += cell.colSpan - 1;
}
//
if (cell.note) {
wjcCore.addClass(cellEl, 'cell-note');
cellEl.title = cell.note.text;
}
}
}
}
//
// pad with empty cells
let padCellsCount = maxRowCells - cellsCnt - invisColCnt;
for (let i = 0; i < padCellsCount; i++) {
rowEl.appendChild(document.createElement('td'));
}
//
if (!rowEl.style.height) {
rowEl.style.height = defaultRowHeight + 'px';
}
}
//
// do it at the end for performance
rootElement.appendChild(tableEl);
}
//
function getVisColSpan(columns, startFrom, colSpan) {
let res = colSpan;
//
for (let i = startFrom; i < columns.length && i < startFrom + colSpan; i++) {
let col = columns[i];
if (col && !col.visible) {
res--;
}
}
//
return res;
}
//
function importStyle(cssStyle, xlsxStyle) {
if (!xlsxStyle) {
return;
}
//
if (xlsxStyle.fill) {
if (xlsxStyle.fill.color) {
cssStyle.backgroundColor = xlsxStyle.fill.color;
}
}
//
if (xlsxStyle.hAlign && xlsxStyle.hAlign != wjcXlsx.HAlign.Fill) {
cssStyle.textAlign = wjcXlsx.HAlign[xlsxStyle.hAlign].toLowerCase();
}
//
let font = xlsxStyle.font;
if (font) {
if (font.family) {
cssStyle.fontFamily = font.family;
}
if (font.bold) {
cssStyle.fontWeight = 'bold';
}
if (font.italic) {
cssStyle.fontStyle = 'italic';
}
if (font.size != null) {
cssStyle.fontSize = font.size + 'px';
}
if (font.underline) {
cssStyle.textDecoration = 'underline';
}
if (font.color) {
cssStyle.color = font.color;
}
}
}
//
function toggleNavActiveStatus(navEle) {
let activeIndex = -1;
let navEles = document.querySelectorAll('#sheetNav li');
for (let i = 0; i < navEles.length; i++) {
let currentItem = navEles[i];
wjcCore.removeClass(currentItem, 'active');
if (currentItem === navEle) {
wjcCore.addClass(currentItem, 'active');
activeIndex = i;
}
}
return activeIndex;
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Workbook Viewer</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div>
<input type="file" class="form-control" id="importFile"
accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12"
style="width:300px" />
</div>
<!-- Sheet tabs -->
<ul id="sheetNav" class="nav nav-tabs" style="margin-top:40px">
</ul>
<!-- Current sheet view -->
<div id="tableHost"></div>
</div>
</body>
</html>
.cell-note {
position: relative;
}
.cell-note:after {
content: "";
position: absolute;
display: block;
top: 0;
right: 0;
border-left: 7px solid transparent;
border-top: 7px solid red;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, enableProdMode, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
//
import * as wjcCore from '@mescius/wijmo';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
//
@Component({
standalone: true,
imports: [BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
workbook: wjcXlsx.Workbook;
sheetIndex: number;
//
ngAfterViewInit() {
document.getElementById('importFile').addEventListener('change', () => {
this._loadWorkbook();
});
}
//
tabClicked(e: MouseEvent, index: number) {
e.preventDefault();
this._drawSheet(index);
}
//
private _loadWorkbook() {
let reader = new FileReader();
//
reader.onload = (e) => {
let workbook = new wjcXlsx.Workbook();
workbook.loadAsync(<string>reader.result, (result: wjcXlsx.Workbook) => {
this.workbook = result;
this._drawSheet(this.workbook.activeWorksheet || 0);
});
};
//
let file = (<HTMLInputElement>document.getElementById('importFile')).files[0];
if (file) {
reader.readAsDataURL(file);
}
}
//
private _drawSheet(sheetIndex: number) {
let drawRoot = document.getElementById('tableHost');
drawRoot.textContent = '';
this.sheetIndex = sheetIndex;
this._drawWorksheet(this.workbook, sheetIndex, drawRoot, 200, 100);
}
//
private _drawWorksheet(
workbook: wjcXlsx.IWorkbook,
sheetIndex: number,
rootElement: HTMLElement,
maxRows: number,
maxColumns: number,
) {
//NOTES:
//Empty cells' values are numeric NaN, format is "General"
//
//Excessive empty properties:
//fill.color = undefined
//
// netFormat should return '' for ''. What is 'General'?
// font.color should start with '#'?
// Column/row styles are applied to each cell style, this is convenient, but Column/row style info should be kept,
// for column/row level styling
// formats conversion is incorrect - dates and virtually everything; netFormat - return array of formats?
// ?row heights - see hello.xlsx
if (!workbook || !workbook.sheets || sheetIndex < 0 || workbook.sheets.length == 0) {
return;
}
//
sheetIndex = Math.min(sheetIndex, workbook.sheets.length - 1);
//
if (maxRows == null) {
maxRows = 200;
}
//
if (maxColumns == null) {
maxColumns = 100;
}
//
// Namespace and XlsxConverter shortcuts.
let sheet = workbook.sheets[sheetIndex],
defaultRowHeight = 20,
defaultColumnWidth = 60,
tableEl = document.createElement('table');
//
tableEl.border = '1';
tableEl.style.borderCollapse = 'collapse';
//
let maxRowCells = 0;
for (let r = 0; sheet.rows && r < sheet.rows.length; r++) {
if (sheet.rows[r] && sheet.rows[r].cells) {
maxRowCells = Math.max(maxRowCells, sheet.rows[r].cells.length);
}
}
//
// add columns
let columns = sheet.columns || [],
invisColCnt = columns.filter((col) => col.visible === false).length;
//
if (sheet.columns) {
maxRowCells = Math.min(Math.max(maxRowCells, columns.length), maxColumns);
//
for (let c = 0; c < maxRowCells; c++) {
let col = columns[c];
//
if (col && !col.visible) {
continue;
}
//
let colEl = document.createElement('col');
tableEl.appendChild(colEl);
let colWidth = defaultColumnWidth + 'px';
if (col) {
this._importStyle(colEl.style, col.style);
if (col.autoWidth) {
colWidth = '';
} else if (col.width != null) {
colWidth = col.width + 'px';
}
}
colEl.style.width = colWidth;
}
}
//
// generate rows
let rowCount = Math.min(maxRows, sheet.rows.length);
for (let r = 0; sheet.rows && r < rowCount; r++) {
let row = sheet.rows[r],
cellsCnt = 0; // including colspan
//
if (row && !row.visible) {
continue;
}
//
let rowEl = document.createElement('tr');
tableEl.appendChild(rowEl);
//
if (row) {
this._importStyle(rowEl.style, row.style);
if (row.height != null) {
rowEl.style.height = row.height + 'px';
}
//
for (let c = 0; row.cells && c < row.cells.length; c++) {
let cell = row.cells[c],
cellEl = document.createElement('td'),
col = columns[c];
//
if (col && !col.visible) {
continue;
}
//
cellsCnt++;
//
rowEl.appendChild(cellEl);
if (cell) {
this._importStyle(cellEl.style, cell.style);
let value = cell.value;
//
if (!(value == null || value !== value)) {
// TBD: check for NaN should be eliminated
if (wjcCore.isString(value) && value.charAt(0) == "'") {
value = value.substr(1);
}
let netFormat = '';
if (cell.style && cell.style.format) {
netFormat = wjcXlsx.Workbook.fromXlsxFormat(cell.style.format)[0];
}
let fmtValue = netFormat ? wjcCore.Globalize.format(value, netFormat) : value;
cellEl.innerHTML = wjcCore.escapeHtml(fmtValue);
}
//
if (cell.colSpan && cell.colSpan > 1) {
cellEl.colSpan = this._getVisColSpan(columns, c, cell.colSpan);
cellsCnt += cellEl.colSpan - 1;
c += cell.colSpan - 1;
}
//
if (cell.note) {
wjcCore.addClass(cellEl, 'cell-note');
cellEl.title = cell.note.text;
}
}
}
}
//
// pad with empty cells
let padCellsCount = maxRowCells - cellsCnt - invisColCnt;
for (let i = 0; i < padCellsCount; i++) {
rowEl.appendChild(document.createElement('td'));
}
//
if (!rowEl.style.height) {
rowEl.style.height = defaultRowHeight + 'px';
}
}
//
// do it at the end for performance
rootElement.appendChild(tableEl);
}
//
private _getVisColSpan(columns: wjcXlsx.IWorkbookColumn[], startFrom: number, colSpan: number) {
let res = colSpan;
//
for (let i = startFrom; i < columns.length && i < startFrom + colSpan; i++) {
let col = columns[i];
if (col && !col.visible) {
res--;
}
}
//
return res;
}
//
private _importStyle(cssStyle: CSSStyleDeclaration, xlsxStyle: wjcXlsx.IWorkbookStyle) {
if (!xlsxStyle) {
return;
}
//
if (xlsxStyle.fill) {
if (xlsxStyle.fill.color) {
cssStyle.backgroundColor = xlsxStyle.fill.color;
}
}
//
if (xlsxStyle.hAlign && xlsxStyle.hAlign != wjcXlsx.HAlign.Fill) {
cssStyle.textAlign = wjcXlsx.HAlign[xlsxStyle.hAlign].toLowerCase();
}
//
let font = xlsxStyle.font;
if (font) {
if (font.family) {
cssStyle.fontFamily = font.family;
}
if (font.bold) {
cssStyle.fontWeight = 'bold';
}
if (font.italic) {
cssStyle.fontStyle = 'italic';
}
if (font.size != null) {
cssStyle.fontSize = font.size + 'px';
}
if (font.underline) {
cssStyle.textDecoration = 'underline';
}
if (font.color) {
cssStyle.color = font.color;
}
}
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Workbook Viewer</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div>
<input type="file" class="form-control" id="importFile"
accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12"
style="width:300px" />
</div>
<!-- Sheet tabs -->
@if (workbook) {
<ul class="nav nav-tabs" style="margin-top:40px">
@for (sheet of workbook.sheets; track sheet.name; let i = $index) {
<li role="presentation" [class.active]="i === sheetIndex">
<a href="#" (click)="tabClicked($event, i)">{{sheet.name}}</a>
</li>
}
</ul>
}
<!-- Current sheet view -->
<div id="tableHost"></div>
</div>
.cell-note {
position: relative;
}
.cell-note:after {
content: "";
position: absolute;
display: block;
top: 0;
right: 0;
border-left: 7px solid transparent;
border-top: 7px solid red;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<div class="container-fluid">
<div>
<input type="file" class="form-control" id="importFile"
accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12"
style="width:300px" />
</div>
<!-- Sheet tabs -->
<ul v-if="workbook != null" class="nav nav-tabs" style="margin-top:40px">
<li role="presentation" v-for="(sheet, index) in workbook.sheets" :key="index"
v-bind:class="{ active: index == sheetIndex }">
<a href="#" @click="tabClicked($event, index)">{{ sheet.name }}</a>
</li>
</ul>
<!-- Current sheet view -->
<div id="tableHost"></div>
</div>
</template>
<script setup>
import * as wjcCore from "@mescius/wijmo";
import * as wjcXlsx from "@mescius/wijmo.xlsx";
import { ref, onMounted } from "vue";
const workbook = ref(null);
const sheetIndex = ref(-1);
onMounted(function () {
document.getElementById("importFile").addEventListener("change", () => {
_loadWorkbook();
});
});
function tabClicked(e, index) {
e.preventDefault();
_drawSheet(index);
}
function _drawSheet(sheetIndexref) {
let drawRoot = document.getElementById("tableHost");
drawRoot.textContent = "";
sheetIndex.value = sheetIndexref;
_drawWorksheet(workbook.value, sheetIndex.value, drawRoot, 200, 100);
}
function _loadWorkbook() {
let reader = new FileReader();
reader.onload = (e) => {
let wbk = new wjcXlsx.Workbook();
wbk.loadAsync(reader.result, (result) => {
workbook.value = result;
_drawSheet(workbook.value.activeWorksheet || 0);
});
};
let file = document.getElementById("importFile").files[0];
if (file) {
reader.readAsDataURL(file);
}
}
function _drawWorksheet(workbook, sheetIndex, rootElement, maxRows, maxColumns) {
//NOTES:
//Empty cells' values are numeric NaN, format is "General"
//
//Excessive empty properties:
//fill.color = undefined
//
// netFormat should return '' for ''. What is 'General'?
// font.color should start with '#'?
// Column/row styles are applied to each cell style, this is convenient, but Column/row style info should be kept,
// for column/row level styling
// formats conversion is incorrect - dates and virtually everything; netFormat - return array of formats?
// ?row heights - see hello.xlsx
if (!workbook || !workbook.sheets || sheetIndex < 0 || workbook.sheets.length == 0) {
return;
}
sheetIndex = Math.min(sheetIndex, workbook.sheets.length - 1);
if (maxRows == null) {
maxRows = 200;
}
if (maxColumns == null) {
maxColumns = 100;
}
// Namespace and XlsxConverter shortcuts.
let sheet = workbook.sheets[sheetIndex],
defaultRowHeight = 20,
defaultColumnWidth = 60,
tableEl = document.createElement("table");
tableEl.border = "1";
tableEl.style.borderCollapse = "collapse";
let maxRowCells = 0;
for (let r = 0; sheet.rows && r < sheet.rows.length; r++) {
if (sheet.rows[r] && sheet.rows[r].cells) {
maxRowCells = Math.max(maxRowCells, sheet.rows[r].cells.length);
}
}
// add columns
let columns = sheet.columns || [],
invisColCnt = columns.filter((col) => col.visible === false).length;
if (sheet.columns) {
maxRowCells = Math.min(Math.max(maxRowCells, columns.length), maxColumns);
for (let c = 0; c < maxRowCells; c++) {
let col = columns[c];
if (col && !col.visible) {
continue;
}
let colEl = document.createElement("col");
tableEl.appendChild(colEl);
let colWidth = defaultColumnWidth + "px";
if (col) {
_importStyle(colEl.style, col.style);
if (col.autoWidth) {
colWidth = "";
} else if (col.width != null) {
colWidth = col.width + "px";
}
}
colEl.style.width = colWidth;
}
}
// generate rows
let rowCount = Math.min(maxRows, sheet.rows.length);
for (let r = 0; sheet.rows && r < rowCount; r++) {
let row = sheet.rows[r],
cellsCnt = 0; // including colspan
if (row && !row.visible) {
continue;
}
let rowEl = document.createElement("tr");
tableEl.appendChild(rowEl);
if (row) {
_importStyle(rowEl.style, row.style);
if (row.height != null) {
rowEl.style.height = row.height + "px";
}
for (let c = 0; row.cells && c < row.cells.length; c++) {
let cell = row.cells[c],
cellEl = document.createElement("td"),
col = columns[c];
if (col && !col.visible) {
continue;
}
cellsCnt++;
rowEl.appendChild(cellEl);
if (cell) {
_importStyle(cellEl.style, cell.style);
let value = cell.value;
if (!(value == null || value !== value)) {
// TBD: check for NaN should be eliminated
if (wjcCore.isString(value) && value.charAt(0) == "'") {
value = value.substr(1);
}
let netFormat = "";
if (cell.style && cell.style.format) {
netFormat = wjcXlsx.Workbook.fromXlsxFormat(cell.style.format)[0];
}
let fmtValue = netFormat ? wjcCore.Globalize.format(value, netFormat) : value;
cellEl.innerHTML = wjcCore.escapeHtml(fmtValue);
}
if (cell.colSpan && cell.colSpan > 1) {
cellEl.colSpan = _getVisColSpan(columns, c, cell.colSpan);
cellsCnt += cellEl.colSpan - 1;
c += cell.colSpan - 1;
}
if (cell.note) {
wjcCore.addClass(cellEl, "cell-note");
cellEl.title = cell.note.text;
}
}
}
}
// pad with empty cells
let padCellsCount = maxRowCells - cellsCnt - invisColCnt;
for (let i = 0; i < padCellsCount; i++) {
rowEl.appendChild(document.createElement("td"));
}
if (!rowEl.style.height) {
rowEl.style.height = defaultRowHeight + "px";
}
}
// do it at the end for performance
rootElement.appendChild(tableEl);
}
function _getVisColSpan(columns, startFrom, colSpan) {
let res = colSpan;
for (let i = startFrom; i < columns.length && i < startFrom + colSpan; i++) {
let col = columns[i];
if (col && !col.visible) {
res--;
}
}
return res;
}
function _importStyle(cssStyle, xlsxStyle) {
if (!xlsxStyle) {
return;
}
if (xlsxStyle.fill) {
if (xlsxStyle.fill.color) {
cssStyle.backgroundColor = xlsxStyle.fill.color;
}
}
if (xlsxStyle.hAlign && xlsxStyle.hAlign != wjcXlsx.HAlign.Fill) {
cssStyle.textAlign = wjcXlsx.HAlign[xlsxStyle.hAlign].toLowerCase();
}
let font = xlsxStyle.font;
if (font) {
if (font.family) {
cssStyle.fontFamily = font.family;
}
if (font.bold) {
cssStyle.fontWeight = "bold";
}
if (font.italic) {
cssStyle.fontStyle = "italic";
}
if (font.size != null) {
cssStyle.fontSize = font.size + "px";
}
if (font.underline) {
cssStyle.textDecoration = "underline";
}
if (font.color) {
cssStyle.color = font.color;
}
}
}
</script>
<style>
.cell-note {
position: relative;
}
.cell-note:after {
content: "";
position: absolute;
display: block;
top: 0;
right: 0;
border-left: 7px solid transparent;
border-top: 7px solid red;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Workbook Viewer</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useEffect, useState } from 'react';
import * as wjcCore from '@mescius/wijmo';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import './app.css';
function App() {
const [workbook, setWorkbook] = useState(null);
const [sheetIndex, setSheetIndex] = useState(0);
const drawSheet = (index) => {
const drawRoot = document.getElementById('tableHost');
if (drawRoot) {
drawRoot.textContent = '';
setSheetIndex(index);
if (workbook) {
drawWorksheet(workbook, index, drawRoot, 200, 100);
}
}
};
const drawWorksheet = (workbook, sheetIndex, rootElement, maxRows, maxColumns) => {
//NOTES:
//Empty cells' values are numeric NaN, format is "General"
//
//Excessive empty properties:
//fill.color = undefined
//
// netFormat should return '' for ''. What is 'General'?
// font.color should start with '#'?
// Column/row styles are applied to each cell style, this is convenient, but Column/row style info should be kept,
// for column/row level styling
// formats conversion is incorrect - dates and virtually everything; netFormat - return array of formats?
// ?row heights - see hello.xlsx
if (!workbook || !workbook.sheets || sheetIndex < 0 || workbook.sheets.length == 0) {
return;
}
sheetIndex = Math.min(sheetIndex, workbook.sheets.length - 1);
if (maxRows == null) {
maxRows = 200;
}
if (maxColumns == null) {
maxColumns = 100;
}
// Namespace and XlsxConverter shortcuts.
let sheet = workbook.sheets[sheetIndex], defaultRowHeight = 20, defaultColumnWidth = 60, tableEl = document.createElement('table');
tableEl.border = '1';
tableEl.style.borderCollapse = 'collapse';
let maxRowCells = 0;
for (let r = 0; sheet.rows && r < sheet.rows.length; r++) {
const cells = sheet.rows[r].cells;
if (sheet.rows[r] && cells) {
maxRowCells = Math.max(maxRowCells, cells.length);
}
}
// add columns
let columns = sheet.columns || [], invisColCnt = columns.filter(col => col.visible === false).length;
if (sheet.columns) {
maxRowCells = Math.min(Math.max(maxRowCells, columns.length), maxColumns);
for (let c = 0; c < maxRowCells; c++) {
let col = columns[c];
if (col && !col.visible) {
continue;
}
let colEl = document.createElement('col');
tableEl.appendChild(colEl);
let colWidth = defaultColumnWidth + 'px';
if (col) {
importStyle(colEl.style, col.style);
if (col.autoWidth) {
colWidth = '';
}
else if (col.width != null) {
colWidth = col.width + 'px';
}
}
colEl.style.width = colWidth;
}
}
if (sheet.rows) {
const rowCount = Math.min(maxRows, sheet.rows.length);
for (let r = 0; sheet.rows && r < rowCount; r++) {
let row = sheet.rows[r], cellsCnt = 0; // including colspan
if (row && !row.visible) {
continue;
}
let rowEl = document.createElement('tr');
tableEl.appendChild(rowEl);
if (row) {
importStyle(rowEl.style, row.style);
if (row.height != null) {
rowEl.style.height = row.height + 'px';
}
for (let c = 0; row.cells && c < row.cells.length; c++) {
let cell = row.cells[c], cellEl = document.createElement('td'), col = columns[c];
if (col && !col.visible) {
continue;
}
cellsCnt++;
rowEl.appendChild(cellEl);
if (cell) {
importStyle(cellEl.style, cell.style);
let value = cell.value;
if (!(value == null || value !== value)) { // TBD: check for NaN should be eliminated
if (wjcCore.isString(value) && value.charAt(0) == "'") {
value = value.substr(1);
}
let netFormat = '';
if (cell.style && cell.style.format) {
netFormat = wjcXlsx.Workbook.fromXlsxFormat(cell.style.format)[0];
}
let fmtValue = netFormat ? wjcCore.Globalize.format(value, netFormat) : value;
cellEl.innerHTML = wjcCore.escapeHtml(fmtValue);
}
if (cell.colSpan && cell.colSpan > 1) {
cellEl.colSpan = getVisColSpan(columns, c, cell.colSpan);
cellsCnt += cellEl.colSpan - 1;
c += cell.colSpan - 1;
}
if (cell.note) {
wjcCore.addClass(cellEl, 'cell-note');
if (cell.note.text) {
cellEl.title = cell.note.text;
}
}
}
}
}
//
// pad with empty cells
let padCellsCount = maxRowCells - cellsCnt - invisColCnt;
for (let i = 0; i < padCellsCount; i++) {
rowEl.appendChild(document.createElement('td'));
}
//
if (!rowEl.style.height) {
rowEl.style.height = defaultRowHeight + 'px';
}
}
}
//
// do it at the end for performance
rootElement.appendChild(tableEl);
};
const getVisColSpan = (columns, startFrom, colSpan) => {
let res = colSpan;
for (let i = startFrom; i < columns.length && i < startFrom + colSpan; i++) {
let col = columns[i];
if (col && !col.visible) {
res--;
}
}
return res;
};
const importStyle = (cssStyle, xlsxStyle) => {
if (!xlsxStyle) {
return;
}
if (xlsxStyle.fill) {
if (xlsxStyle.fill.color) {
cssStyle.backgroundColor = xlsxStyle.fill.color;
}
}
if (xlsxStyle.hAlign && xlsxStyle.hAlign != wjcXlsx.HAlign.Fill) {
cssStyle.textAlign = wjcXlsx.HAlign[xlsxStyle.hAlign].toLowerCase();
}
let font = xlsxStyle.font;
if (font) {
if (font.family) {
cssStyle.fontFamily = font.family;
}
if (font.bold) {
cssStyle.fontWeight = 'bold';
}
if (font.italic) {
cssStyle.fontStyle = 'italic';
}
if (font.size != null) {
cssStyle.fontSize = font.size + 'px';
}
if (font.underline) {
cssStyle.textDecoration = 'underline';
}
if (font.color) {
cssStyle.color = font.color;
}
}
};
const handleFileInputChange = (event) => {
const files = event.currentTarget.files;
if (files && files.length) {
const file = files[0];
const reader = new FileReader();
reader.onload = () => {
const workbook = new wjcXlsx.Workbook();
workbook.loadAsync(reader.result, (result) => {
setWorkbook(result);
});
};
reader.readAsDataURL(file);
}
};
useEffect(() => {
if (workbook) {
drawSheet(workbook.activeWorksheet || 0);
}
}, [workbook]);
const renderList = () => {
let lists = [];
if (workbook) {
for (let i = 0; i < workbook.sheets.length; i++) {
const sheet = workbook.sheets[i];
lists.push(<li key={i} role="presentation" className={i === sheetIndex ? 'active' : ''}>
<a href="#" onClick={e => { e.preventDefault(); drawSheet(i); }}>
{sheet.name}
</a>
</li>);
}
}
return (<ul className="nav nav-tabs" style={{ marginTop: 40 }}>
{lists}
</ul>);
};
return (<div className="container-fluid">
<div>
<input id="importFile" type="file" className="form-control" accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12" style={{
width: 300
}} onChange={handleFileInputChange}/>
</div>
{renderList()}
<div id="tableHost"></div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo Workbook Viewer</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.cell-note {
position: relative;
}
.cell-note:after {
content: "";
position: absolute;
display: block;
top: 0;
right: 0;
border-left: 7px solid transparent;
border-top: 7px solid red;
}
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);